// This file was generated from JSON Schema using quicktype, do not modify it directly.
// To parse the JSON, add this file to your project and do:
//
//   let welcome = try? newJSONDecoder().decode(Welcome.self, from: jsonData)

//
// To read values from URLs:
//
//   let task = URLSession.shared.welcomeTask(with: url) { welcome, response, error in
//     if let welcome = welcome {
//       ...
//     }
//   }
//   task.resume()

import Foundation
import SwiftUI

struct PIResult: Codable{
    var data: Welcome
}

// MARK: - Welcome
struct Welcome: Codable {
    var videos: [VideoVideo]
    var count: Int

   /* enum CodingKeys: String, CodingKey {
        case videos = "videos"
        case count = "count"
    }*/
}

//
// To read values from URLs:
//
//   let task = URLSession.shared.videoElementTask(with: url) { videoElement, response, error in
//     if let videoElement = videoElement {
//       ...
//     }
//   }
//   task.resume()

// MARK: - VideoElement
struct VideoElement: Codable {
    var video: [VideoVideo]
    var rating: String
    var thumb: [String:String]
    var title: String
    var url: [[String:String]]
    enum CodingKeys: String, CodingKey {
        case video = "video"
        case rating = "rating"
        case thumb = "thumb"
        case title = "title"
        case url = "url"
    }
    
}

//
// To read values from URLs:
//
//   let task = URLSession.shared.videoVideoTask(with: url) { videoVideo, response, error in
//     if let videoVideo = videoVideo {
//       ...
//     }
//   }
//   task.resume()

// MARK: - VideoVideo
struct VideoVideo:  Codable {
    var duration: String
    var views: Int
    var videoID: String
    var rating: String
    var ratings: Int
    var title: String
    var url: [[String:String]]
    var embedURL: String
    var defaultThumb: String
    var thumb: [String:String]
    var publishDate: String
    var thumbs: [Thumb]
    var tags: [Tag]

    enum CodingKeys: String, CodingKey {
        case duration = "duration"
        case views = "views"
        case videoID = "video_id"
        case rating = "rating"
        case ratings = "ratings"
        case title = "title"
        case url = "url"
        case embedURL = "embed_url"
        case defaultThumb = "default_thumb"
        case thumb = "thumb"
        case publishDate = "publish_date"
        case thumbs = "thumbs"
        case tags = "tags"
    }
}

//
// To read values from URLs:
//
//   let task = URLSession.shared.tagTask(with: url) { tag, response, error in
//     if let tag = tag {
//       ...
//     }
//   }
//   task.resume()

// MARK: - Tag
struct Tag: Codable {
    var tagName: String

    enum CodingKeys: String, CodingKey {
        case tagName = "tag_name"
    }
}

//
// To read values from URLs:
//
//   let task = URLSession.shared.thumbTask(with: url) { thumb, response, error in
//     if let thumb = thumb {
//       ...
//     }
//   }
//   task.resume()

// MARK: - Thumb
struct Thumb: Codable {
    var size: String
    var width: Int
    var height: Int
    var src: String

    enum CodingKeys: String, CodingKey {
        case size = "size"
        case width = "width"
        case height = "height"
        case src = "src"
    }
}

// MARK: - Helper functions for creating encoders and decoders

func newJSONDecoder() -> JSONDecoder {
    let decoder = JSONDecoder()
    if #available(iOS 10.0, OSX 10.12, tvOS 10.0, watchOS 3.0, *) {
        decoder.dateDecodingStrategy = .iso8601
    }
    return decoder
}

func newJSONEncoder() -> JSONEncoder {
    let encoder = JSONEncoder()
    if #available(iOS 10.0, OSX 10.12, tvOS 10.0, watchOS 3.0, *) {
        encoder.dateEncodingStrategy = .iso8601
    }
    return encoder
}


// MARK: - URLSession response handlers

extension URLSession {
    fileprivate func codableTask<T: Codable>(with url: URL, completionHandler: @escaping (T?, URLResponse?, Error?) -> Void) -> URLSessionDataTask {
        return self.dataTask(with: url) { data, response, error in
            guard let data = data, error == nil else {
                completionHandler(nil, response, error)
                return
            }
            completionHandler(try? newJSONDecoder().decode(T.self, from: data), response, nil)
        }
    }

    func welcomeTask(with url: URL, completionHandler: @escaping (Welcome?, URLResponse?, Error?) -> Void) -> URLSessionDataTask {
        return self.codableTask(with: url, completionHandler: completionHandler)
    }
}




